#==============================================================================
#
#  $Id: MainLoop.py 602 2000-03-28 01:36:04Z mike $
#
"""
   Module for MainLoop class.
"""
#
#  Copyright (C) 1999 Michael A. Muller
#
#  Permission is granted to use, modify and redistribute this code,
#  providing that the following conditions are met:
#
#  1) This copyright/licensing notice must remain intact.
#  2) If the code is modified and redistributed, the modifications must 
#  include documentation indicating that the code has been modified.
#  3) The author(s) of this code must be indemnified and held harmless
#  against any damage resulting from the use of this code.
#
#  This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
#  warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
#
#  $Log: MainLoop.py,v $
#  Revision 1.1  2000/03/28 01:36:04  mike
#  Created new class to house common "main loop" functionality.
#
#
#==============================================================================

class MainLoop:
   """
      Mix-in base class for windows that have a @mainloop() method.
   """

   def __init__(self):
      self.__finished = 0
   
   def terminate(self):
      """
         Causes the main loop to terminate.
      """
      self.__finished = 1

   def mainloop(self):
      """
         Continue processing events until terminated.
      """
      self.__finished = 0
      while not self.__finished:
         
         # get the next character, convert it to an event object, and
         # dispatch its event
         evt = self.getEvent()         
         self.processEvent(evt)


   
