#==============================================================================
#
#  $Id: TkRenderer.py 461 1999-05-23 17:45:38Z mike $
#
"""
   Contains the Tk renderers for phunky view objects
"""
#
#  Copyright (C) 1999 Michael A. Muller
#
#  Permission is granted to use, modify and redistribute this code,
#  providing that the following conditions are met:
#
#  1) This copyright/licensing notice must remain intact.
#  2) If the code is modified and redistributed, the modifications must 
#  include documentation indicating that the code has been modified.
#  3) The author(s) of this code must be indemnified and held harmless
#  against any damage resulting from the use of this code.
#
#  This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
#  warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
#
#  $Log: TkRenderer.py,v $
#  Revision 1.1  1999/05/23 17:45:38  mike
#  Tk renderer for phunky views
#
#
#==============================================================================

from Tkinter import *

from phunkyvw import Renderer, Utility, RendererFactory

class StringEditor(Renderer, Utility):
   
   def __init__(self, parent, editor, **attrs):
      Renderer.__init__(self, editor)
      tmpAttrs = self._selectAttrs(attrs, 
                                   (('label', 'text'),
                                    )
                                   )
                                          
      self.label = apply(Label, (parent,), tmpAttrs)
      tmpAttrs = self._selectAttrs(attrs, ('width'))
      self.text = apply(Entry, (parent,), tmpAttrs)
      tmpAttrs = self._selectAttrs(attrs, 
                                   ('row', 'column', 'rowspan', 'columnspan',
                                    'sticky'
                                    )
                                   )
      apply(self.label.grid, (), tmpAttrs)
      tmpAttrs['column'] = tmpAttrs.get('column', 0) + 1
      apply(self.text.grid, (), tmpAttrs)
   
   def set(self, text):
      self.text.delete(0, 'end')
      self.text.insert(0, text)
   
   def get(self):
      return self.text.get()

class Form(Renderer, Utility, Frame):
         
   def __init__(self, parent, editor, **attrs):
      Renderer.__init__(self, editor)
      Frame.__init__(self, parent)
      self.pack(expand = 1, fill = 'both')

class TkRendererFactory(RendererFactory):
   
   __map = \
      {
      'StringEditor': StringEditor,
      'Form': Form,
      }
   
   def create(self, className, parent, objectEditor, attrs):
      return apply(self.__map[className], (parent, objectEditor), attrs)
