/*===========================================================================*\

   $Id$

   Copyright (C) 2007 Michael A. Muller

   Permission is granted to use, modify and redistribute this code,
   providing that the following conditions are met:
 
   1) This copyright/licensing notice must remain intact.
   2) If the code is modified and redistributed, the modifications must 
   include documentation indicating that the code has been modified.
   3) The author(s) of this code must be indemnified and held harmless
   against any damage resulting from the use of this code.

   This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
   warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

\*===========================================================================*/

#ifndef AUDIODRIVER_H
#define AUDIODRIVER_H

#include "AudioPlayer.h"
#include "Sample.h"
#include "Camera.h"

/** Interface for all audio implementations */
class AudioDriver {
   public:

      /**
       * Creates a new audio sample from the given file.
       */
      virtual SamplePtr createSampleFromFile(const char *filename) = 0;

      /**
       * Create a new audio player.
       * @param sample the sample that the player will play.
       */
      virtual AudioPlayerPtr createPlayer(const SamplePtr &sample) = 0;

      /**
       * Function to get called from the render loop.  Keeps the sound running
       * smoothly.
       * @param listener the position/orientation of the microphone
       */
      virtual void process(const Camera &listener, long elapsedTime) = 0;
};

#endif
