#ifndef PYTHONPLUGIN_H
#define PYTHONPLUGIN_H

#include <spug/Exception.h>

class DisplayDriver;
class GameEngine;
class AudioDriver;

SPUG_EXCEPTION(PluginError);

class PythonPlugin {
   private:
      static DisplayDriver *displayDriver;
      friend DisplayDriver *getDisplayDriver();
      static GameEngine *gameEngine;
      friend GameEngine *getGameEngine();
      static AudioDriver *audioDriver;
      friend AudioDriver *getAudioDriver();
   public:
      void setDisplayDriver(DisplayDriver *displayDriver);
      void setGameEngine(GameEngine *gameEngine);
      void setAudioDriver(AudioDriver *audioDriver);
      void handleInit();
      void handleTerminate();
};

#endif
