/*===========================================================================*\

   $Id$

   Copyright (C) 2007 Michael A. Muller

   Permission is granted to use, modify and redistribute this code,
   providing that the following conditions are met:
 
   1) This copyright/licensing notice must remain intact.
   2) If the code is modified and redistributed, the modifications must 
   include documentation indicating that the code has been modified.
   3) The author(s) of this code must be indemnified and held harmless
   against any damage resulting from the use of this code.

   This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
   warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

\*===========================================================================*/

#ifndef QUADPANE_H
#define QUADPANE_H

#include "Material.h"
#include "RenderableObject.h"

class Scene;

SPUG_RCPTR(QuadPane);

/**
 * a QuadPane is essentially a quad object for use in the HUD.  It allows you
 * to display materials (colors and textures) on the HUD.
 */
class QuadPane : public RenderableObject {
   private:

      Float left, top, width, height;
      MaterialPtr material;

   public:
      QuadPane(Float left, Float top, Float width, Float height,
               const MaterialPtr &material
               );

      virtual void render(Scene &scene);
};

#endif
