/*===========================================================================*\

   $Id$

   Copyright (C) 2007 Michael A. Muller

   Permission is granted to use, modify and redistribute this code,
   providing that the following conditions are met:
 
   1) This copyright/licensing notice must remain intact.
   2) If the code is modified and redistributed, the modifications must 
   include documentation indicating that the code has been modified.
   3) The author(s) of this code must be indemnified and held harmless
   against any damage resulting from the use of this code.

   This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
   warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

\*===========================================================================*/

#ifndef WURLDSDLAUDIO_H
#define WURLDSDLAUDIO_H

#include <map>
#include <spug/Mutex.h>
#include "AudioDriver.h"

SPUG_RCPTR(WurldSDLAudioPlayer);

/**
 * Audio implentation based on the SDL Mixer library.
 */
class WurldSDLAudio : public AudioDriver {
   friend class WurldSDLAudioPlayer;
   private:
      spug::Mutex mapLock;
      typedef std::map<int, WurldSDLAudioPlayerPtr> PlayerMap;
      PlayerMap players;

      static WurldSDLAudio *instance;

      // adds the player to the set of those currently playing
      void addPlayer(int channel, const AudioPlayerPtr &player);

   public:

      WurldSDLAudio();
      ~WurldSDLAudio();

      virtual SamplePtr createSampleFromFile(const char *filename);
      virtual AudioPlayerPtr createPlayer(const SamplePtr &sample);
      virtual void process(const Camera &listener, long elapsedTime);

      static WurldSDLAudio *getInstance() {
         return instance;
      }

      void handlePlayerStopped(int channel);
};

#endif
